DECLARE SUB DATAREAD ()
REM AT24C64 EEPROM MEMORY WITH I2C BUS
REM READ PROCEEDURE-RANDOM READ
DECLARE SUB STOPCOND ()
DECLARE SUB START ()
DECLARE SUB OUTBYTE ()
DECLARE SUB WAITACK ()
CLS
OPEN "COM1:4800,n,8,1,CS,DS,CD" FOR RANDOM AS #1
DIM B(8)
INPUT "DATA ADDRESS="; ADDRESS
DEVICE = 0: REM DEVICE=0,2,4,6 FOR THE 1st,2nd,3rd,4th MEM ICs.
DEFAULT = 160
RWBit = 0: REM RW IS 0 FOR WRITE AND 1 FOR READ
DEVADDR = DEFAULT + DEVICE + RWBit
ADDR2 = ADDRESS MOD 256: REM LS BYTE ADDR1 CAN VARY BETWEEN 0-256
ADDR1 = (ADDRESS - ADDR2) / 256: REM MS BYTE ADDR2 CAN VARY BETWEEN 0-31
REM MEM ADDRESS CAN VARY BETWEEN 0-8192
OUT &H3FC, (&H2 OR INP(&H3FC)): REM SCL LOW

REM DUMMY WRITE
REM-------------

REM START CONDITION
CALL START
PRINT "START OK"

REM DEVICE ADDRESS OUTPUT
BYTE = DEVADDR
CALL OUTBYTE
PRINT " DEVICE ADDRESS OK"

REM WAIT FOR SLAVE ACK
CALL WAITACK

REM OUTPUT FIRST WORD ADDRESS
BYTE = ADDR1
CALL OUTBYTE
PRINT " FIRST ADDR BYTE OK"

REM WAIT FOR SLAVE ACK
CALL WAITACK

REM OUTPUT SECOND WORD ADDRESS
BYTE = ADDR2
CALL OUTBYTE
PRINT " SECOND ADDR BYTE OK"

REM WAIT FOR SLAVE ACK
CALL WAITACK

REM RANDOM READ
REM--------------
RWBit = 1
DEVADDR = DEFAULT + DEVICE + RWBit

REM START CONDITION
CALL START
PRINT "START OK"

REM DEVICE ADDRESS OUTPUT
BYTE = DEVADDR
CALL OUTBYTE
PRINT " DEVICE ADDRESS OK"

REM WAIT FOR SLAVE ACK
CALL WAITACK

REM READ WORD FROM MEMORY ADDRESS
CALL DATAREAD

REM STOP CONDITION
CALL STOPCOND
PRINT
PRINT "STOP OK"









SUB DATAREAD
SHARED ADDRESS
DATAbyte = 0
OUT &H3F8 + 3, (&H40 OR INP(&H3F8 + 3)): REM SDA RELEASED
FOR I = 7 TO 0 STEP -1
OUT &H3FC, (&HFD AND INP(&H3FC)): REM SCL HIGH   
IF (INP(&H3FE) AND 16) = 16 THEN
DATAbyte = DATAbyte + 0
ELSE DATAbyte = DATAbyte + 2 ^ I
END IF
OUT &H3FC, (&H2 OR INP(&H3FC)): REM SCL LOW 
NEXT I
PRINT
PRINT "DATAbyte IN MEMORY ADDRESS"; ADDRESS; "="; DATAbyte

END SUB

SUB OUTBYTE
SHARED BYTE
REM BYTE OUTPUT
DIM B(8)
X = BYTE
FOR I = 0 TO 7
B(I) = X MOD 2
X = INT(X / 2)
NEXT I
PRINT
FOR I = 7 TO 0 STEP -1
IF B(I) = 1 THEN
OUT &H3F8 + 3, (&H40 OR INP(&H3F8 + 3)): REM B6 of LCR inactive
ELSE
OUT &H3F8 + 3, (&HBF AND INP(&H3F8 + 3)): REM B6 of LCR selected
END IF
OUT &H3FC, (&HFD AND INP(&H3FC)): REM SCL HIGH
PRINT B(I);
OUT &H3FC, (&H2 OR INP(&H3FC)): REM SCL LOW   
NEXT I

END SUB

SUB START
REM START CONDITION
OUT (&H3F8 + 3), (&H40 OR INP(&H3F8 + 3)): REM SDA HIGH

OUT &H3FC, (&HFD AND INP(&H3FC)): REM SCL HIGH

OUT (&H3F8 + 3), (&HBF AND INP(&H3F8 + 3)): REM SDA LOW

OUT &H3FC, (&H2 OR INP(&H3FC)): REM SCL LOW


END SUB

SUB STOPCOND
REM STOP CONDITION
OUT (&H3F8 + 3), (&HBF AND INP(&H3F8 + 3)): REM SDA LOW  
OUT &H3FC, (&HFD AND INP(&H3FC)): REM SCL HIGH         
OUT (&H3F8 + 3), (&H40 OR INP(&H3F8 + 3)): REM SDA HIGH       
OUT &H3FC, (&H2 OR INP(&H3FC)): REM SCL LOW
END SUB

SUB WAITACK
REM WAIT FOR SLAVE ACK
OUT (&H3F8 + 3), (&H40 OR INP(&H3F8 + 3)): REM SDA HIGH
PRINT "WAITING FOR SLAVE ACK"
OUT &H3FC, (&HFD AND INP(&H3FC)): REM SCL HIGH     
WHILE (INP(&H3FE) AND 16) <> 16
WEND
PRINT "SLAVE ACKNOWLEDGED"
OUT &H3FC, (&H2 OR INP(&H3FC)): REM SCL LOW

END SUB

